package edu.uconn.engr.dna.isoem;

import java.util.List;
import java.util.Map;

public interface ReadClassPartitionAlgo {

    /**
     * Given isoform and read coordinates, finds the set of isoforms compatible
     * to each read
     * 
     * @return a collection of ReadClass-es generated by the given reads
     */
    Map<Integer, IsoformList> findIsoformsForReads(
	    List<Coord> sortedReadCoordinates, List<Coord> sortedIsoformCoord);

    Map<Integer, Integer> getFragmentLengthCounts();
}
